Botan: Botan::Fanout_Filter Class Reference

Botan 1.10.16

Public Member Functions | Protected Member Functions | List of all members
Botan::Fanout_Filter Class Referenceabstract

`#include <filter.h>`

Inheritance diagram for Botan::Fanout_Filter:

## Public Member Functions
virtual bool | attachable ()
virtual void | end_msg ()
virtual std::string | name () const =0
virtual void | start_msg ()
virtual void | write (const byte input[], size_t length)=0

## Protected Member Functions
void | attach (Filter *f)
void | incr_owns ()
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)
void | set_next (Filter *f[], size_t n)
void | set_port (size_t n)

## Detailed Description

This is the abstract Fanout_Filter base class.

Definition at line 134 of file filter.h.

## Member Function Documentation

## ◆ attach()

void Botan::Fanout_Filter::attach | ( | Filter * | f | ) |
| inlineprotected

Definition at line 146 of file filter.h.

146 { Filter::attach(f); }

## ◆ attachable()

virtual bool Botan::Filter::attachable | ( |  | ) |
| inlinevirtualinherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 50 of file filter.h.

50 { return true; }

## ◆ end_msg()

virtual void Botan::Filter::end_msg | ( |  | ) |
| inlinevirtualinherited

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented in Botan::MAC_Filter, Botan::Hash_Filter, Botan::PK_Verifier_Filter, Botan::Base64_Decoder, Botan::Hex_Decoder, Botan::PK_Signer_Filter, Botan::Zlib_Decompression, Botan::Bzip_Decompression, Botan::PK_Decryptor_Filter, Botan::PBE_PKCS5v20, Botan::Base64_Encoder, Botan::Hex_Encoder, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, Botan::Zlib_Compression, and Botan::PK_Encryptor_Filter.

Definition at line 44 of file filter.h.

Referenced by Botan::Filter::send().

44 {}

## ◆ incr_owns()

void Botan::Fanout_Filter::incr_owns | ( |  | ) |
| inlineprotected

Increment the number of filters past us that we own

Definition at line 140 of file filter.h.

140 { ++filter_owns; }

## ◆ name()

virtual std::string Botan::Filter::name | ( |  | ) | const
| pure virtualinherited

Returns
  descriptive name for this filter

Implemented in Botan::MAC_Filter, Botan::Hash_Filter, Botan::PK_Verifier_Filter, Botan::XTS_Decryption, Botan::CBC_Decryption, Botan::Fork, Botan::Hex_Decoder, Botan::Base64_Decoder, Botan::ECB_Decryption, Botan::PK_Signer_Filter, Botan::CTS_Decryption, Botan::CFB_Decryption, Botan::Zlib_Decompression, Botan::Bzip_Decompression, Botan::PK_Decryptor_Filter, Botan::EAX_Base, Botan::StreamCipher_Filter, Botan::Chain, Botan::DataSink_Stream, Botan::XTS_Encryption, Botan::PBE_PKCS5v20, Botan::Hex_Encoder, Botan::CBC_Encryption, Botan::ECB_Encryption, Botan::PBE_PKCS5v15, Botan::BitBucket, Botan::Bzip_Compression, Botan::CFB_Encryption, Botan::CTS_Encryption, Botan::PK_Encryptor_Filter, Botan::SecureQueue, Botan::Zlib_Compression, and Botan::Base64_Encoder.

Referenced by Botan::Keyed_Filter::set_iv().

## ◆ send() [1/4]

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protectedinherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::Filter::end_msg(), Botan::MemoryRegion< T >::size(), Botan::Filter::start_msg(), and Botan::Filter::write().

Referenced by Botan::Base64_Encoder::Base64_Encoder(), Botan::EAX_Decryption::EAX_Decryption(), Botan::PK_Encryptor_Filter::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::PBE_PKCS5v15::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::PBE_PKCS5v20::end_msg(), Botan::PK_Decryptor_Filter::end_msg(), Botan::Bzip_Decompression::end_msg(), Botan::Zlib_Decompression::end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::PK_Verifier_Filter::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Botan::Hex_Encoder::Hex_Encoder(), Botan::ECB_Encryption::name(), Botan::EAX_Base::name(), Botan::ECB_Decryption::name(), Botan::CTS_Encryption::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::CBC_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), Botan::CTS_Decryption::set_iv(), Botan::CBC_Decryption::set_iv(), Botan::XTS_Encryption::set_key(), Botan::XTS_Decryption::set_key(), Botan::Zlib_Compression::write(), Botan::Bzip_Compression::write(), Botan::StreamCipher_Filter::write(), Botan::Bzip_Decompression::write(), Botan::Zlib_Decompression::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:152
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [2/4]

void Botan::Filter::send | ( | byte | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ send() [3/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [4/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inlineprotectedinherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ set_next()

void Botan::Fanout_Filter::set_next | ( | Filter * | f[],
|  | size_t | n
| ) |  |
| inlineprotected

Definition at line 144 of file filter.h.

Referenced by Botan::SecureQueue::SecureQueue().

144 { Filter::set_next(f, n); }

## ◆ set_port()

void Botan::Fanout_Filter::set_port | ( | size_t | n | ) |
| inlineprotected

Definition at line 142 of file filter.h.

142 { Filter::set_port(n); }

## ◆ start_msg()

virtual void Botan::Filter::start_msg | ( |  | ) |
| inlinevirtualinherited

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented in Botan::Zlib_Decompression, Botan::EAX_Base, Botan::Bzip_Decompression, Botan::PBE_PKCS5v20, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, and Botan::Zlib_Compression.

Definition at line 38 of file filter.h.

Referenced by Botan::Filter::send().

38 {}

## ◆ write()

virtual void Botan::Filter::write | ( | const byte | input[],
|  | size_t | length
| ) |  |
| pure virtualinherited

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implemented in Botan::MAC_Filter, Botan::Hash_Filter, Botan::PK_Verifier_Filter, Botan::Base64_Decoder, Botan::Hex_Decoder, Botan::PK_Signer_Filter, Botan::Fork, Botan::Zlib_Decompression, Botan::Bzip_Decompression, Botan::StreamCipher_Filter, Botan::PK_Decryptor_Filter, Botan::DataSink_Stream, Botan::Chain, Botan::PBE_PKCS5v20, Botan::Hex_Encoder, Botan::Base64_Encoder, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, Botan::PK_Encryptor_Filter, Botan::SecureQueue, Botan::Zlib_Compression, and Botan::BitBucket.

Referenced by Botan::Filter::send(), and Botan::Pipe::write().

The documentation for this class was generated from the following file:

- src/filters/filter.h